package pl.net.linux.krzak.kchat.sac;
/*****************************/
/* kChat v2.0		     */
/* kChatSac v0.91	     */
/* krzak@linux.net.pl        */
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.List;
import pl.net.linux.krzak.kchat.util.kChatParse;

public class SacProtocol {
    private kChatParse parse = new kChatParse();
    private SacMainWindow main = null;

    public SacProtocol(SacMainWindow m) {
	main = m;
    }

    public void parse(String buf) {
    if (buf.startsWith("*MSG"))
 {
	String who = parse.getParam(buf,2);
	String where = parse.getParam(buf,3);
	String text = parse.getParam(buf,4);
	String color = parse.getParam(buf,5);
        String s = "<"+who+"> "+text;
	// priv, lub do moderatora
	if (where.equals(main.login))
 {
    		if  ((main.alreadyExistNick(who) == false)) {
			MsgFloatingWindow fw = new MsgFloatingWindow("Chat with "+who,who,main);
			fw.setVisible(true);
			fw.text.append("*<"+ who +">* " + text + "\n");
			} else {
			MsgFloatingWindow fw = main.getMsgWindowFromList(who);
			fw.text.append("*<"+ who +">* " + text + "\n");
			}
	}
    }

    if (buf.startsWith("*LIST"))
 {
	int start = 5;	int end = 5;
	while (buf.indexOf("|",start+1) != -1) {
	    start = end+1;
	    end   = buf.indexOf("|",start+1);
	    if ((start<end) && (!buf.substring(start,end).equals(main.login))) main.nList.add(buf.substring(start,end));
	    }
    }

    if (buf.startsWith("*JOIN"))
 {
	String n = parse.getParam(buf,2);
	if (!n.equals(main.login))
	    main.nList.add(n);
    }

    if (buf.startsWith("*QUIT"))
 {
	String n = parse.getParam(buf,2);
	for (int i=0;i<main.nList.getItemCount();i++) {
		if ((main.nList != null) && (main.nList.getItem(i).equals(n)))
		    main.nList.remove(i);
	    }
    }

/*    if (buf.startsWith("*MODERATED")) {
	if (buf.substring(11,13).equals("NO")) {
	    main.moderate=false;
	    main.moderatorNick = "";
	    main.chanWnd.appendText(main.TXT[4] ,"gray"); // "kanal nie jest moderowany"
	    } else {
	    main.moderate=true;
	    main.moderatorNick = parse.getParam(buf,3);
	    if (!main.moderatorNick.equals(main.login)) {
		main.moderFr.dispose();
		main.chanWndModer=null;
		}
	    main.chanWnd.appendText(main.compileText(main.TXT[3],main.moderatorNick),"gray"); // "kanal moderowany przez "
	    }
    }


    if (buf.startsWith("*YOUAREMODERATOR")) {
	    main.moderate=true;
	    main.chanWnd.appendText(main.compileText(main.TXT[14],main.chan),"red"); // "jestes moderatorem"
	    main.moderWinOpen(main);
	    main.chanWndModer.moderatorMode=true;
	    main.bPrivate.setLabel(main.TXT[16]);
	    main.bPrivate.setActionCommand("KICK");
	    main.bModerator.setLabel(main.TXT[17]);
	    main.bModerator.setActionCommand("TOPIC");
    }
*/
    if (buf.startsWith("*LOGIN"))
 { 
	    String s = parse.getParam(buf,2);
	    if (s.equals("OK")) {
		main.login=parse.getParam
(buf,3);
//		main.chanWnd.appendText(main.TXT[0],"black");
//		main.net.send("*MODERATED");
		}
	    if (s.equals("NICK BUSY")) {
		main.status.setText("Login busy!!!");
//		main.chanWnd.appendText(main.TXT[11],"black"); // "login zajety"
		}

	}
/*
    if (buf.startsWith("*KICK"))
 {
	main.chanWnd.appendText(main.TXT[15],"black");
	main.net.send("*CLOSE\r\n");
	main.net.disconnect();
	main.net=null;
	main.actions=null;
	main.context.showDocument(main.logouthtml,"_self");
	main = null;
    }

*/
    if (buf.startsWith("*PING"))
	main.net.send("*PONG\r\n");

/*
    if (buf.startsWith("*LANG"))
 {
	for (int i=0;i<main.TXT.length;i++) {
	    main.TXT[i] = parse.getParam(buf,i+2);
	    }
	main.bPrivate.setLabel(main.TXT[6]);
	main.bModerator.setLabel(main.TXT[7]);
	main.bLogout.setLabel(main.TXT[8]);
	main.bClose.setLabel(main.TXT[9]);
    }
*/

  }

}